#include <iostream>
#include <stdio.h>
#include <string.h>
int main()
{
    using namespace std;
    int i,c,r=0;
    char a[200000],b[200000];
    string a1;
    cin>>a;
    c = strlen(a);
    for (int i=0;i<c;i++){
      if ( isupper(a[i]))
        abort();
    }

       if (c==2)
    {
        cout<<"2";
          return 1;
    }
       if (a[0]==a[2] && a[0]!=a[3] && c!=3 )
    {
        cout<<"3";
          return 1;
    }
    else {

    for (int i=0,j=c-1;i<c;i++,j--)
    {
        b[i]=a[j];
    }
     for (int i=0;i<c;i++)
    {
        if (a[i]==b[i])
        {
            r++;
        }
        else
        {
            return 1;
        }
    }
    if (c%2==0 && r==c)
    {
        cout<<"1";
        return 1;
    }
    else if (c%2!=0 && r==c)
    {
        cout<<"1";
          return 1;
  }


    }
}